
#property copyright "Copyright  2014, TLP"
#property link      "http://www.google.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Black

#import "RenkoBarsEngine.dll"
   int initDLL(int a0, int a1);
   string getDLLVer(int a0);
   int updateDW(int a0);
   int updateT1(int a0, int a1);
   int processHistoryBar4Renko(double a0, int a1, double& a2[], double& a3[], double& a4[], double& a5[], int a6);
#import

extern double RenkoBoxSizeInPips = 10.0;
extern int OfflineTimeFrame = 3;
bool useFirstRenkoPipOffset = FALSE;
double FirstRenkoPipOffset = 0.0;
extern string _BarType.equal_to.0 = "Standard RENKO";
extern string _BarType.equal_to.1 = "RENKO with wicks";
string _BarType.equal_to.2 = "RENKO for EA backtesting";
extern int BarType = 1;
bool Gi_128 = FALSE;
int Gi_132 = 0;
int Gi_136 = 0;
extern int RenderUsing1MhistoryBars = 0;
datetime StartFromBar = 0;
extern bool RefreshOnHistoryUpdates = FALSE;
extern bool RefreshChartOnAskPriceChange = FALSE;
extern bool UseSoundSignalOnNewBar = FALSE;
extern string SoundFile = "clock_tick.wav";
string G_name_168 = "RenkoPlugIn";
string Gs_176 = "";
int G_file_184 = -1;
int Gi_unused_188 = 0;
int Gi_unused_192 = 0;
double G_iclose_196 = 0.0;
double G_iclose_204 = 0.0;
double G_iclose_212 = 0.0;
double G_iclose_220 = 0.0;
double Gd_228 = 0.0;
double Gda_236[5] = {0, 0, 0, 0, 0};
string G_dbl2str_240 = "1.0";
int Gi_248;
int Gi_252 = 0;
int Gi_256 = 400;
string Gs_260;
string Gs_268;
int Gi_276;
int G_digits_280;
int Gia_284[13];
double Gd_288 = 0.0;
double G_iclose_296;
double Gd_304 = 0.0;
bool Gi_312 = FALSE;
bool Gi_316 = FALSE;
bool Gi_320 = FALSE;
bool Gi_unused_324 = FALSE;
int Gi_328 = 0;
bool Gi_unused_332 = FALSE;
double G_iclose_336;
bool Gi_344 = FALSE;
bool Gi_348 = TRUE;
int Gi_352;

// 895C12182B5529BD03F449B34CFFE809
double f0_4() {
   double Lda_0[6] = {1, 10, 100, 1000, 10000, 100000};
   if (Digits > 0) return (0.1 / (Lda_0[Digits - 1]));
   if (Digits == 0) return (1);
   return (0.0);
}
			 			       		  			 	 	  		    		    						   	    	  	    				 	   	 		 	  		  	  			 	  	 		  			     	 			 				  				   	 	 	      			      
// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   string Ls_4;
   Gs_176 = "Renko Plug-in (c)2011-12 NiX ver." + "1.07 " + "(" + DoubleToStr(RenkoBoxSizeInPips, 1) + "," + OfflineTimeFrame + ")";
   IndicatorShortName(Gs_176);
   G_name_168 = "RenkoPlugIn" + DoubleToStr(RenkoBoxSizeInPips, 1) + "-" + OfflineTimeFrame;
   int Li_ret_0 = initDLL(0, WindowHandle(Symbol(), Period()));
   if (Li_ret_0 == 0) {
      Alert("Plug-in not activated or trial period over...");
      Gi_320 = TRUE;
      return (Li_ret_0);
   }
   if (Li_ret_0 == 1) {
      Ls_4 = getDLLVer(2);
      if (Ls_4 == "20121122.1") {
         Print("RenkoBar Plug-in " + "1.07 " + " [" + getDLLVer(2) + "] initialized (OK)");
         Gi_320 = FALSE;
      } else {
         Alert("Error - Incorrect DLL Version!");
         Gi_320 = TRUE;
         return (0);
      }
   }
   if (useFirstRenkoPipOffset && MathAbs(FirstRenkoPipOffset) >= RenkoBoxSizeInPips) {
      Gi_320 = TRUE;
      Alert("FirstRenkoPipOffset has to be less then RenkoBoxSizeInPips (" + RenkoBoxSizeInPips + "pips)!");
      Comment("RenkoBarChart DISABLED, please set FirstRenkoPipOffset correctly.");
      return (0);
   }
   if (BarType < 0 && BarType > 2) BarType = 0;
   return (0);
}
	    	   		 	  	 	 	    				  	     	 			  	  	 			 			 			 		 			  	   	 			  	 	  		 	  	    	 	 	  	  	   	  	  		  		 	 				  	 	 	 	   	 	  
// A20E3B53FBDFFF2A8F9D56077DE04EAA
int f0_5(string As_unused_0 = "", int Ai_unused_8 = 0) {
   G_dbl2str_240 = DoubleToStr(RenkoBoxSizeInPips, 1);
   if (Digits % 2 > 0) {
      RenkoBoxSizeInPips = 10.0 * RenkoBoxSizeInPips;
      FirstRenkoPipOffset = 10.0 * FirstRenkoPipOffset;
   }
   if (f0_4() != MarketInfo(Symbol(), MODE_TICKSIZE)) RenkoBoxSizeInPips /= MarketInfo(Symbol(), MODE_TICKSIZE);
   Gs_268 = Symbol();
   Gi_276 = OfflineTimeFrame;
   G_digits_280 = Digits;
   switch (OfflineTimeFrame) {
   case 0:
   case 1:
   case 5:
   case 15:
   case 30:
   case 60:
   case 240:
   case 1440:
   case 10080:
   case 43200:
      Alert(OfflineTimeFrame + " is a Metatrader4 reserver time frame. Please choose a different value (i.e. 2,3,4,6,7,8,9,10.... Exiting...");
      Gi_316 = TRUE;
      return (0);
   }
   if (!IsDllsAllowed()) Alert("The live renko feed will not work if DLL calls are disabled!");
   int window_16 = WindowFind(Gs_176);
   ObjectCreate(G_name_168, OBJ_LABEL, window_16, 0, 0);
   ObjectSetText(G_name_168, "Open " + Symbol() + ",M" + OfflineTimeFrame + " offline chart for " + G_dbl2str_240 + " pip renko bars.", 7, "Verdana", Yellow);
   ObjectSet(G_name_168, OBJPROP_CORNER, 0);
   ObjectSet(G_name_168, OBJPROP_XDISTANCE, 3);
   ObjectSet(G_name_168, OBJPROP_YDISTANCE, 17);
   Gd_288 = NormalizeDouble(RenkoBoxSizeInPips * Point, Digits);
   if (RenkoBoxSizeInPips <= 0.0) return (0);
   Gi_312 = FALSE;
   return (f0_7());
}
					 		   	 		   	 					   		 	 			 	  			 		 		  	   		  	  	 	 		 					   		   		  	  	 				   	 		 	  			 					  		 		 	     	 	 	 					 	 	 
// 52D46093050F38C27267BCE42543EF60
int deinit() {
   if (G_file_184 >= 0) {
      FileClose(G_file_184);
      G_file_184 = -1;
   }
   ObjectDelete(G_name_168);
   if (Gi_320 == TRUE) Comment("");
   return (0);
}
	 	  	 			  	   				   	 	 	  			 	 	 	   		  		 	  				 	  		   		 	  	   		   			 		  	       				  					  	 	  			       			 	   	 		  	 	 			
// D125BA8A0E466C012D023149E8FDEF24
int f0_7() {
   double Ld_8;
   int datetime_16;
   if (G_file_184 >= 0) {
      FileFlush(G_file_184);
      FileClose(G_file_184);
      G_file_184 = -1;
      Gi_unused_188 = 0;
   }
   G_file_184 = FileOpenHistory(Gs_268 + Gi_276 + ".hst", FILE_BIN|FILE_WRITE);
   if (G_file_184 < 0) return (-1);
   Gs_260 = "(C)opyright 2011, NiX";
   FileWriteInteger(G_file_184, Gi_256, LONG_VALUE);
   FileWriteString(G_file_184, Gs_260, 64);
   FileWriteString(G_file_184, Gs_268, 12);
   FileWriteInteger(G_file_184, Gi_276, LONG_VALUE);
   FileWriteInteger(G_file_184, G_digits_280, LONG_VALUE);
   FileWriteInteger(G_file_184, 0, LONG_VALUE);
   FileWriteInteger(G_file_184, 0, LONG_VALUE);
   FileWriteArray(G_file_184, Gia_284, 0, 13);
   FileFlush(G_file_184);
   Gda_236[0] = 0;
   Gda_236[1] = 0;
   Gda_236[2] = 0;
   Gda_236[3] = 0;
   Gda_236[4] = 0;
   Gi_252 = FALSE;
   f0_3();
   int Li_0 = 0;
   int Li_4 = iBars(Symbol(), PERIOD_M1);
   if (Li_4 > RenderUsing1MhistoryBars) {
      if (RenderUsing1MhistoryBars == 0) Li_0 = Li_4;
      else Li_0 = RenderUsing1MhistoryBars;
   } else Li_0 = Li_4;
   Li_0--;
   if (useFirstRenkoPipOffset) {
      Ld_8 = NormalizeDouble(FirstRenkoPipOffset * Point + MathFloor(iOpen(Symbol(), PERIOD_M1, Li_0) / Gd_288) * Gd_288, Digits);
      f0_1(iTime(Symbol(), PERIOD_M1, Li_0), Ld_8, Ld_8, Ld_8, Ld_8, 1, 1);
   }
   for (Gi_248 = Li_0; Gi_248 > 0; Gi_248--) {
      RefreshRates();
      datetime_16 = iTime(Symbol(), PERIOD_M1, Gi_248);
      if (StartFromBar != 0)
         if (datetime_16 < StartFromBar) continue;
      Gd_304 += iVolume(Symbol(), PERIOD_M1, Gi_248);
      if (Gi_128) {
         if (f0_2(datetime_16)) {
            f0_0(datetime_16, G_iclose_196, G_iclose_204, G_iclose_212, G_iclose_220, Gd_228, 1);
            f0_3();
         }
      }
      f0_1(datetime_16, iOpen(Symbol(), PERIOD_M1, Gi_248), iLow(Symbol(), PERIOD_M1, Gi_248), iHigh(Symbol(), PERIOD_M1, Gi_248), iClose(Symbol(), PERIOD_M1, Gi_248),
         Gd_304, 1);
   }
   RefreshRates();
   Gi_312 = TRUE;
   Gi_316 = FALSE;
   Gd_304 += iVolume(Symbol(), PERIOD_M1, 0);
   f0_1(iTime(Symbol(), PERIOD_M1, 0), iOpen(Symbol(), PERIOD_M1, 0), iLow(Symbol(), PERIOD_M1, 0), iHigh(Symbol(), PERIOD_M1, 0), iClose(Symbol(), PERIOD_M1, 0), Gd_304,
      1);
   updateDW(WindowHandle(Gs_268, OfflineTimeFrame));
   return (100);
}
	   			 			   				 		 	  				   	      	   		    		  	   		  			 	    	   		  				   				 	 	 				 		   		  			    	  		  	  	 		 	             	
// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   int datetime_4;
   if (Gi_328 != 100 || Gi_316 || Gi_320) {
      if (Gi_320) return (-4);
      Gi_328 = f0_5();
      if (Gi_328 != 100) return (-2);
      if (Gi_316) return (-3);
   }
   int ind_counted_0 = IndicatorCounted();
   if (ind_counted_0 < 0) return (-1);
   if (ind_counted_0 == 0) {
      if (RefreshOnHistoryUpdates == TRUE) {
         Print("More history downloaded - resynchronizing with market");
         Gi_312 = FALSE;
         Gi_252 = FALSE;
         Gi_344 = TRUE;
      }
   }
   if (Gi_344 == TRUE) {
      f0_7();
      Gi_344 = FALSE;
      return (-1);
   }
   G_iclose_336 = iClose(Symbol(), PERIOD_M1, 0);
   if (G_iclose_296 != G_iclose_336) {
      G_iclose_296 = G_iclose_336;
      if (G_iclose_196 != 0.0) {
         if (G_iclose_212 < G_iclose_336) G_iclose_212 = G_iclose_336;
         if (G_iclose_204 > G_iclose_336) G_iclose_204 = G_iclose_336;
         G_iclose_220 = G_iclose_336;
         Gd_228 += 1.0;
      } else {
         G_iclose_212 = G_iclose_336;
         G_iclose_204 = G_iclose_336;
         G_iclose_196 = G_iclose_336;
         G_iclose_220 = G_iclose_336;
         Gd_228 = 1;
      }
      datetime_4 = iTime(Symbol(), PERIOD_M1, 0);
      if (Gi_128) {
         if (f0_2(datetime_4)) {
            f0_0(datetime_4, G_iclose_196, G_iclose_204, G_iclose_212, G_iclose_220, Gd_228, 1);
            f0_3();
         }
      }
      f0_1(datetime_4, G_iclose_196, G_iclose_204, G_iclose_212, G_iclose_220, Gd_228, 1);
      updateDW(WindowHandle(Gs_268, OfflineTimeFrame));
   } else
      if (RefreshChartOnAskPriceChange) updateDW(WindowHandle(Gs_268, OfflineTimeFrame));
   return (0);
}
	  	     					 	 	   	  			  		    						    		 					 	 					  			 			  	 	 		 	 	 		  	  		 	 	 	   		  	 	    	   		 		 			 		  					 	  				  
// 2365E543C282F21BF1C2ED63BF809CB2
void f0_0(int Ai_0, double Ad_4, double Ad_12, double Ad_20, double Ad_28, double Ad_36, int Ai_44) {
   int Li_48;
   if (Gi_348) {
      if (G_file_184 >= 0) {
         FileSeek(G_file_184, 0, SEEK_END);
         FileWriteInteger(G_file_184, Ai_0, LONG_VALUE);
         FileWriteDouble(G_file_184, Ad_4, DOUBLE_VALUE);
         FileWriteDouble(G_file_184, Ad_12, DOUBLE_VALUE);
         FileWriteDouble(G_file_184, Ad_20, DOUBLE_VALUE);
         FileWriteDouble(G_file_184, Ad_28, DOUBLE_VALUE);
         FileWriteDouble(G_file_184, Ad_36, DOUBLE_VALUE);
         FileFlush(G_file_184);
      }
      Gi_348 = FALSE;
      return;
   }
   if (G_file_184 >= 0) {
      if (Ai_44 == 1) {
         Li_48 = updateT1(Ai_0, Gi_252);
         FileSeek(G_file_184, 0, SEEK_END);
         FileWriteInteger(G_file_184, Li_48, LONG_VALUE);
         Gi_252 = Li_48;
      } else FileSeek(G_file_184, -40, SEEK_END);
      FileWriteDouble(G_file_184, Ad_4, DOUBLE_VALUE);
      FileWriteDouble(G_file_184, Ad_12, DOUBLE_VALUE);
      FileWriteDouble(G_file_184, Ad_20, DOUBLE_VALUE);
      FileWriteDouble(G_file_184, Ad_28, DOUBLE_VALUE);
      FileWriteDouble(G_file_184, Ad_36, DOUBLE_VALUE);
      FileFlush(G_file_184);
      if (Ai_44 == 1 && Gi_312 && UseSoundSignalOnNewBar == TRUE) {
         if (SoundFile == "alert_box") Alert("New bar on " + G_dbl2str_240 + "pip chart for " + Symbol());
         else PlaySound(SoundFile);
      }
   }
}
	  		    			 	 	 	  		  			 			    	 				   			 				  	 				   			 	 	  	 	  	 	 	 	   	  				 	 	  			  	 		   	    	 		 		  		  		 		 	  	 		  
// A280C4D8395804B5D591A96F82E4F624
void f0_6(double A_iclose_0, double A_iclose_8, double A_iclose_16, double A_iclose_24, double Ad_32) {
   G_iclose_196 = A_iclose_0;
   G_iclose_204 = A_iclose_8;
   G_iclose_212 = A_iclose_16;
   G_iclose_220 = A_iclose_24;
   Gd_228 = Ad_32;
}
	 		 			 	 		 	  		   				     	  			   	 	    			 			 			 				 					 			   	 	  						    	  	  		    	 			 				 	 	 	 	  			     		  		 			  	 
// 7068B05C5C914623CCBF7B2B32EE1273
void f0_3() {
   G_iclose_196 = 0;
   G_iclose_204 = 0;
   G_iclose_212 = 0;
   G_iclose_220 = 0;
   Gd_228 = 0;
}
	   	 	  		  			 	 				 						       	 		  			  			     			   				   		 	 		 			 	    		  	 				 	 			   	  	 	 	  	 				 	    	  	  	  	    	   
// 528A25D75BD8D4BB42A9E48F11ED06BB
int f0_1(int Ai_0, double Ad_4, double Ad_12, double Ad_20, double Ad_28, double Ad_36, int Ai_44) {
   double Lda_48[5] = {0, 0, 0, 0, 0};
   Lda_48[0] = Ad_4;
   Lda_48[1] = Ad_12;
   Lda_48[2] = Ad_20;
   Lda_48[3] = Ad_28;
   Lda_48[4] = Ad_36;
   double Lda_52[5] = {0, 0, 0, 0, 0};
   Lda_52[0] = G_iclose_196;
   Lda_52[1] = G_iclose_204;
   Lda_52[2] = G_iclose_212;
   Lda_52[3] = G_iclose_220;
   Lda_52[4] = Gd_228;
   double Lda_56[5] = {0, 0, 0, 0, 0};
   int Li_60 = processHistoryBar4Renko(Gd_288, BarType, Lda_48, Gda_236, Lda_52, Lda_56, Ai_44);
   while (true) {
      if (Li_60 >= 1 && Li_60 <= 4) {
         f0_0(Ai_0, Lda_56[0], Lda_56[1], Lda_56[2], Lda_56[3], Lda_56[4], 0);
         f0_6(Lda_52[0], Lda_52[1], Lda_52[2], Lda_52[3], Lda_52[4]);
         f0_0(Ai_0, Lda_52[0], Lda_52[1], Lda_52[2], Lda_52[3], Lda_52[4], 1);
         Lda_48[0] = G_iclose_196;
         Lda_48[1] = G_iclose_204;
         Lda_48[2] = G_iclose_212;
         Lda_48[3] = G_iclose_220;
         Lda_48[4] = 1;
         Li_60 = processHistoryBar4Renko(Gd_288, BarType, Lda_48, Gda_236, Lda_52, Lda_56, 0);
      } else {
         if (Li_60 == 10) {
            f0_6(Lda_52[0], Lda_52[1], Lda_52[2], Lda_52[3], Lda_52[4]);
            f0_0(Ai_0, Lda_56[0], Lda_56[1], Lda_56[2], Lda_56[3], Lda_56[4], 0);
            Gd_304 = Lda_52[4];
            return (1);
         }
         if (Li_60 == 11) Alert("debug = return 11");
         else {
            if (Li_60 != -1) break;
            Alert("debug = return -1");
         }
      }
   }
   return (1);
}
	 		 					 		 	 			   		 	     		 			     	    	 	 			 	 	 				  				 		    	 	 							 	  	  	 			    					 			  	 	 	    			  	  		  	  			  		
// 5E8C399824969E49C2BFC454CB70EA26
int f0_2(int Ai_0) {
   RefreshRates();
   if (TimeHour(Ai_0) != Gi_136 || TimeMinute(Ai_0) != Gi_132) return (0);
   if (Gi_352 != Ai_0) {
      Gi_352 = Ai_0;
      return (1);
   }
   return (0);
}
